#!/bin/sh

type=$1
prov_type=$(/usr/local/bin/beroconf get root provisioning-option | grep -v failed)
cd /usr/conf

function get_file {

#prov_type="http"	
if [ "$prov_type" = "http" ] ; then
       echo "  == http fetching file $url/$1"        
		http_host=$(/usr/local/bin/beroconf get root http-host | grep -v failed)
		http_url=$(/usr/local/bin/beroconf get root http-url | grep -v failed)
		#prepared to transmit user-agent when busybox wget supports this option
		#HWaddress=`/sbin/ifconfig eth0 |/bin/grep Hwaddr | awk '{ print $5 }'`
        #/usr/bin/wget --user-agent '<berofix:'$Hwaddress'>' http://$http_host/$http_url/$1
        /usr/bin/wget http://$http_host/$http_url/$1
else
       echo "  == tftp fetching file $url/$1"
		host=$(/usr/local/bin/beroconf get root tftp-host | grep -v failed)
		url=$(/usr/local/bin/beroconf get root tftp-url | grep -v failed)
        /usr/local/bin/tftp $host > /dev/null <<EOF
timeout 1
get $url/$1
EOF
fi
}

function reload_settings {
        echo "reloading settings"
        STR=$(echo 'rd'|nc localhost 54322 -q1)
        sleep 1
        STR=$(echo 'rs'|nc localhost 54322 -q1)
}
function update_config {
        if [ -s conf-update.conf ]; then
                . conf-update.conf
                if [ "$CONF_DOWNLOAD" = "yes" ] ; then
                        #echo "  = $prov_type update: checking for files on $host:/$url"
                        mkdir -p backup
                        cp -f isgw.* backup/
                        cp -f isdn.conf backup/
                        rm -rf isgw.conf isgw.sip isgw.dialplan isgw.isdn
                        rm -rf isdn.conf
                        sync
                        get_file isdn.conf
                        get_file isgw.conf
                        get_file isgw.dialplan
                        get_file isgw.isdn
                        get_file isgw.sip
                        sync
                        sleep 1
			if ( ! [ -s isdn.conf ] || ! [ -s isgw.conf ] || ! [ -s isgw.dialplan ] || ! [ -s isgw.sip ]); then
                                restoreoldconfig
				rm -f /usr/conf/conf-update.conf
				sync
                                echo "config_update:$prov_type:error:Download_Config_Files_Failed"
                                exit 0                                                                                      
                        fi                
                        /usr/bin/env -i bash -c "/usr/local/www/berogui/misc/ini_to_db.php"
                        if [ "$?" -eq 0 ] ; then
                                #rm -f backup/isgw.*
                                #rm -f backup/isdn.conf
                                sync
                                echo "config_update:$prov_type:success"
                        else
                                #restoreoldconfig
                                echo "config_update:$prov_type:error:Check_Config_Files"
                        fi
                else
                        echo "config_update:$prov_type:failed:No_Config_Download_Selected"
                fi
                sync
else
        echo "config_update:$prov_type:failed:Downloading_conf-update.conf"
fi

rm -f /usr/conf/conf-update.conf
sync

}
function upgrade_firmware {


if [ -s firmware-update.conf ] ; then
        . firmware-update.conf

        if [ "$FIRMWARE_DOWNLOAD" = "yes" ] ; then
                #echo "  ** Firmware Update Request, using '$FIRMWARE_FILE'"
                cd /mnt/images
                if ! [ -f /mnt/images/$FIRMWARE_FILE ] ; then
                        rm -rf *
                        get_file $FIRMWARE_FILE
                        if ! [ -s /mnt/images/$FIRMWARE_FILE ] ; then
                                echo "firmware_update:$prov_type:failed:Invalid_Firmware_File_'$FIRMWARE_FILE'"
                                exit 0
                        fi
                else
                        echo "firmware_update:$prov_type:failed:Firmware_Image_already_exists"
                        exit 0
                fi
                if [ "$FIRMWARE_INSTALL" = "yes" ] ; then
                        INSTALLED=$(cat /usr/local/FILENAME)

                        if [ "$INSTALLED" != "$FIRMWARE_FILE" ] ; then
                                /usr/local/sbin/install.sh $FIRMWARE_FILE
                                /usr/local/bin/beroconf set root app-image $FIRMWARE_FILE
                                echo "firmware_update:$prov_type:success:Installed_'$FIRMWARE_FILE'"
                        else
                            if [ "$FIRMWARE_REINSTALL" = "yes" ] ; then
                                    #echo "  ** re-installing '$FIRMWARE_FILE'"
                                    /usr/local/sbin/install.sh $FIRMWARE_FILE
                            else
                                    echo "firmware_update:$prov_type:failed:Firmware_'$INSTALLED'_Already_Installed"
                            fi
                        fi
                else
                        echo "firmware_update:$prov_type:failed:Install=No_Selected"
                fi
        else
                echo "firmware_update:$prov_type:Download=No_Selected"
        fi
else
      echo "firmware_update:$prov_type:failed:Missing_File_firmware-update.conf"
fi
rm -f /usr/conf/firmware-update.conf
sync
}
function restoreoldconfig {
     echo "Restore old Config"                                                      
     cp -f backup/isgw.* . 
     cp -f backup/isdn.conf . 
     /usr/bin/env -i bash -c "/usr/local/www/berogui/misc/ini_to_db.php"
     sync
     sleep 1
}

if [ "$type" = "config" ] ; then
	get_file conf-update.conf
	update_config
fi
	
if [ "$type" = "firmware" ] ; then
	get_file firmware-update.conf
	upgrade_firmware
fi

if [ "$type" = "restore" ] ; then
	if ( [ -s backup/isdn.conf ] || [ -s backup/isgw.conf ] || [ -s backup/isgw.dialplan ] || [ -s backup/isgw.sip ]); then
		restoreoldconfig
	      	echo "restoreoldconfig:success"
	else
	      	echo "restoreoldconfig:failed"
	fi
fi

