#!/bin/bash
#
# This script is executed only once, immediately after the image
# tarball is unpacked to the app partition (/usr/local).
#

function need_replace {

	old_v=`egrep 'VERSION=[0-9]*' ${1}`
	new_v=`egrep 'VERSION=[0-9]*' ${2}`

	old_v=${old_v#VERSION=}
	new_v=${new_v#VERSION=}

	if [ "${old_v}" = "" ]; then
		return 0
	fi

	if [ "${old_v}" -ge "${new_v}" ]; then
		return 1
	else
		return 0
	fi

	return 0
}

# update ld.so.cache
mount -oremount,rw /
/sbin/ldconfig

if [ ! -c /dev/bfpga ] ; then
	mknod /dev/bfpga c 254 0
fi

if [ ! -f /usr/lib/mod_auth.so ] ; then
    cp /usr/local/conf/mod_auth.so /usr/lib/
    cp /usr/local/conf/lighttpd.conf /etc/
fi

if need_replace "/etc/init.d/S40network" "/usr/local/conf/S40network" ; then
    cp /usr/local/conf/S40network /etc/init.d/
fi

if need_replace "/usr/sbin/update-time" "/usr/local/conf/update-time" ; then
    cp /usr/local/conf/update-time /usr/sbin/
fi

#if need_replace "/etc/init.d/S30factorydef" "/usr/local/conf/S30factorydef" ; then
#    cp /usr/local/conf/S30factorydef /etc/init.d/
#fi

mount -oremount,ro /


if [ ! -d /usr/local/www/api ] ; then
    mkdir -p /usr/local/www/api
fi

if [ ! -f /usr/conf/apiusers.conf ] ; then
    echo "admin:admin" > /usr/conf/apiusers.conf
fi

if [ ! -f /usr/conf/isgw.tones ] ; then
	cp /usr/local/conf/isgw.tones /usr/conf
fi

if [ ! -f /usr/conf/isgw.causes ] ; then
	cp /usr/local/conf/isgw.causes /usr/conf
fi

MTU=$(/usr/local/bin/beroconf get root lan-mtu)
if [ "$MTU" = "500" ] ; then
        /usr/local/bin/beroconf set root lan-mtu 1500
fi

/usr/bin/env -i bash -c "/usr/bin/php-cgi /usr/local/www/berogui/includes/create_files.php  > /dev/null"

